--- old/usr/src/lib/libc/port/locale/mbrlen.c	Tue May 20 07:58:49 2014
+++ new/usr/src/lib/libc/port/locale/mbrlen.c	Tue May 20 07:58:49 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -27,14 +28,23 @@
 
 #include "lint.h"
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
 
 size_t
-mbrlen(const char *_RESTRICT_KYWD s, size_t n, mbstate_t *_RESTRICT_KYWD ps)
+mbrlen_l(const char *_RESTRICT_KYWD s, size_t n, mbstate_t *_RESTRICT_KYWD ps,
+    locale_t loc)
 {
 	static mbstate_t mbs;
 
 	if (ps == NULL)
 		ps = &mbs;
-	return (__mbrtowc(NULL, s, n, ps));
+	return (mbrtowc_l(NULL, s, n, ps, loc));
+}
+
+size_t
+mbrlen(const char *_RESTRICT_KYWD s, size_t n, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (mbrlen_l(s, n, ps, uselocale(NULL)));
 }
